#include "netif/ethernetif.h" 
#include "enc28j60.h"  
#include "lwip_comm.h" 
#include "malloc.h"
#include "netif/etharp.h"  
#include "string.h" 

//ethernetif_init()ڳʼӲ
//netif:ṹָ 
//ֵ:ERR_OK,
//       ,ʧ
static err_t low_level_init(struct netif *netif)
{
	netif->hwaddr_len = ETHARP_HWADDR_LEN; //MACַ,Ϊ6ֽ
	//ʼMACַ,ʲôַûԼ,ǲ豸MACַظ
	netif->hwaddr[0]=lwipdev.mac[0]; 
	netif->hwaddr[1]=lwipdev.mac[1]; 
	netif->hwaddr[2]=lwipdev.mac[2];
	netif->hwaddr[3]=lwipdev.mac[3];
	netif->hwaddr[4]=lwipdev.mac[4];
	netif->hwaddr[5]=lwipdev.mac[5];
	netif->mtu=1500; //䵥Ԫ,㲥ARP
	netif->flags = NETIF_FLAG_BROADCAST|NETIF_FLAG_ETHARP|NETIF_FLAG_LINK_UP;		
	return ERR_OK;
} 
//ڷݰײ㺯(lwipͨnetif->linkoutputָú)
//netif:ṹָ
//p:pbufݽṹָ
//ֵ:ERR_OK,
//       ERR_MEM,ʧ
static err_t low_level_output(struct netif *netif,struct pbuf *p)
{
	struct pbuf *q;
	int l=0;
	u8 *buffer;
	buffer=mymalloc(SRAMIN,p->tot_len);	//ڴ
	if(buffer==NULL)printf("ݻڴʧ\r\n");
	for(q=p;q!=NULL;q=q->next) 
	{
		memcpy((u8_t*)&buffer[l], q->payload, q->len);
		l=l+q->len;
	} 
	ENC28J60_Packet_Send(p->tot_len,buffer);
	myfree(SRAMIN,buffer);				//ͷڴ
	return ERR_OK;
}  
///ڽݰײ㺯
//neitif:ṹָ
//ֵ:pbufݽṹָ
static struct pbuf * low_level_input(struct netif *netif)
{  
	struct pbuf *p,*q;
	u32 len;
	u8 *buffer;
	int l=0;
	
	p=NULL;
	buffer=mymalloc(SRAMIN,1600);			//ڴ
	if(buffer!=NULL)len=ENC28J60_Packet_Receive(MAX_FRAMELEN,buffer);	//
	else 
	{
		printf("ݻڴʧ\r\n");
		return p;
	}
	p=pbuf_alloc(PBUF_RAW,len,PBUF_POOL);	//pbufsڴطpbuf
	if(p!=NULL)
	{
		for(q=p;q!=NULL;q=q->next)
		{
			memcpy((u8_t*)q->payload,(u8_t*)&buffer[l], q->len);
			l=l+q->len;
		}    
	}
	myfree(SRAMIN,buffer);					//ͷڴ
	return p;
}
//(lwipֱӵ)
//netif:ṹָ
//ֵ:ERR_OK,
//       ERR_MEM,ʧ
err_t ethernetif_input(struct netif *netif)
{
	err_t err;
	struct pbuf *p;
	p=low_level_input(netif);   //low_level_input
	if(p==NULL) return ERR_MEM;
	err=netif->input(p, netif); //netifṹеinputֶ(һ)ݰ
	if(err!=ERR_OK)
	{
		LWIP_DEBUGF(NETIF_DEBUG,("ethernetif_input: IP input error\n"));
		pbuf_free(p);
		p = NULL;
	} 
	return err;
} 
//ʹlow_level_init()ʼ
//netif:ṹָ
//ֵ:ERR_OK,
//       ,ʧ
err_t ethernetif_init(struct netif *netif)
{
	LWIP_ASSERT("netif!=NULL",(netif!=NULL));
#if LWIP_NETIF_HOSTNAME			//LWIP_NETIF_HOSTNAME 
	netif->hostname="lwip";  	//ʼ
#endif 
	netif->name[0]=IFNAME0; 	//ʼnetifnameֶ
	netif->name[1]=IFNAME1; 	//ļⶨﲻùľֵ
	netif->output=etharp_output;//IP㷢ݰ
	netif->linkoutput=low_level_output;//ARPģ鷢ݰ
	low_level_init(netif); 		//ײӲʼ
	return ERR_OK;
}














