#ifndef _LWIP_COMM_H
#define _LWIP_COMM_H 
#include "enc28j60.h" 

#define LWIP_MAX_DHCP_TRIES		4   //DHCPԴ
   
//lwipƽṹ
typedef struct  
{
	u8 mac[6];      //MACַ
	u8 remoteip[4];	//ԶIPַ 
	u8 ip[4];       //IPַ
	u8 netmask[4]; 	//
	u8 gateway[4]; 	//ĬصIPַ
	
	vu8 dhcpstatus;	//dhcp״̬ 
					//0,δȡDHCPַ;
					//1,DHCPȡ״̬
					//2,ɹȡDHCPַ
					//0XFF,ȡʧ.
}__lwip_dev;
extern __lwip_dev lwipdev;	//lwipƽṹ

void lwip_pkt_handle(void);
void lwip_periodic_handle(void);
	
void lwip_comm_default_ip_set(__lwip_dev *lwipx);
u8 lwip_comm_mem_malloc(void);
void lwip_comm_mem_free(void);
u8 lwip_comm_init(void);
void lwip_dhcp_process_handle(void);

#endif













