#include "lwip_comm.h" 
#include "netif/etharp.h"
#include "lwip/dhcp.h"
#include "lwip/mem.h"
#include "lwip/memp.h"
#include "lwip/init.h"
#include "ethernetif.h" 
#include "lwip/timers.h"
#include "lwip/tcp_impl.h"
#include "lwip/ip_frag.h"
#include "lwip/tcpip.h" 
#include "malloc.h"
#include "delay.h"
#include "usart.h"  
#include <stdio.h>
//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//ALIENTEK Ӣ
//lwipͨ 	   
//ԭ@ALIENTEK
//̳:www.openedv.com
//:2015/3/15
//汾V1.0
//ȨУؾ
//Copyright(C) ӿƼ޹˾ 2009-2019
//All rights reserved									  
//*******************************************************************************
//޸Ϣ
//
////////////////////////////////////////////////////////////////////////////////// 	   
   
__lwip_dev lwipdev;						//lwipƽṹ 
struct netif lwip_netif;				//һȫֵӿ

extern u32 memp_get_memorysize(void);	//memp.c涨
extern u8_t *memp_memory;				//memp.c涨.
extern u8_t *ram_heap;					//mem.c涨.

u32 TCPTimer=0;			//TCPѯʱ
u32 ARPTimer=0;			//ARPѯʱ
u32 lwip_localtime;		//lwipʱ,λ:ms

#if LWIP_DHCP
u32 DHCPfineTimer=0;	//DHCPϸʱ
u32 DHCPcoarseTimer=0;	//DHCPֲڴʱ
#endif

//lwipmemmempڴ
//ֵ:0,ɹ;
//    ,ʧ
u8 lwip_comm_mem_malloc(void)
{
	u32 mempsize;
	u32 ramheapsize; 
	mempsize=memp_get_memorysize();			//õmemp_memoryС
	memp_memory=mymalloc(SRAMIN,mempsize);	//Ϊmemp_memoryڴ
	ramheapsize=LWIP_MEM_ALIGN_SIZE(MEM_SIZE)+2*LWIP_MEM_ALIGN_SIZE(4*3)+MEM_ALIGNMENT;//õram heapС
	ram_heap=mymalloc(SRAMIN,ramheapsize);	//Ϊram_heapڴ 
	if(!memp_memory||!ram_heap)//ʧܵ
	{
		lwip_comm_mem_free();
		return 1;
	}
	return 0;	
}
//lwipmemmempڴͷ
void lwip_comm_mem_free(void)
{ 	
	myfree(SRAMIN,memp_memory);
	myfree(SRAMIN,ram_heap);
}
//lwip ĬIP
//lwipx:lwipƽṹָ
void lwip_comm_default_ip_set(__lwip_dev *lwipx)
{
	//ĬԶIPΪ:192.168.1.100
	lwipx->remoteip[0]=192;	
	lwipx->remoteip[1]=168;
	lwipx->remoteip[2]=20;
	lwipx->remoteip[3]=110;
	//MACַ(ֽڹ̶Ϊ:2.0.0,ֽSTM32ΨһID)
	lwipx->mac[0]=enc28j60_dev.macaddr[0];
	lwipx->mac[1]=enc28j60_dev.macaddr[1];
	lwipx->mac[2]=enc28j60_dev.macaddr[2];
	lwipx->mac[3]=enc28j60_dev.macaddr[3];
	lwipx->mac[4]=enc28j60_dev.macaddr[4];
	lwipx->mac[5]=enc28j60_dev.macaddr[5]; 
	//ĬϱIPΪ:192.168.1.30
	lwipx->ip[0]=192;	
	lwipx->ip[1]=168;
	lwipx->ip[2]=20;
	lwipx->ip[3]=130;
	//Ĭ:255.255.255.0
	lwipx->netmask[0]=255;	
	lwipx->netmask[1]=255;
	lwipx->netmask[2]=255;
	lwipx->netmask[3]=0;
	//Ĭ:192.168.1.1
	lwipx->gateway[0]=192;	
	lwipx->gateway[1]=168;
	lwipx->gateway[2]=20;
	lwipx->gateway[3]=1;	
	lwipx->dhcpstatus=0;//ûDHCP	
} 

//LWIPʼ(LWIPʱʹ)
//ֵ:0,ɹ
//      1,ڴ
//      2,DM9000ʼʧ
//      3,ʧ.
u8 lwip_comm_init(void)
{
	struct netif *Netif_Init_Flag;		//netif_add()ʱķֵ,жʼǷɹ
	struct ip_addr ipaddr;  			//ipַ
	struct ip_addr netmask; 			//
	struct ip_addr gw;      			//Ĭ 
	if(lwip_comm_mem_malloc())return 1;	//ڴʧ
	if(ENC28J60_Init())        return 2;			//ʼENC28J60
	lwip_init();						//ʼLWIPں
	lwip_comm_default_ip_set(&lwipdev);	//ĬIPϢ

#if LWIP_DHCP		//ʹö̬IP
	ipaddr.addr = 0;
	netmask.addr = 0;
	gw.addr = 0;
#else				//ʹþ̬IP
	IP4_ADDR(&ipaddr,lwipdev.ip[0],lwipdev.ip[1],lwipdev.ip[2],lwipdev.ip[3]);
	IP4_ADDR(&netmask,lwipdev.netmask[0],lwipdev.netmask[1] ,lwipdev.netmask[2],lwipdev.netmask[3]);
	IP4_ADDR(&gw,lwipdev.gateway[0],lwipdev.gateway[1],lwipdev.gateway[2],lwipdev.gateway[3]);
	printf("enMACַΪ:................%d.%d.%d.%d.%d.%d\r\n",lwipdev.mac[0],lwipdev.mac[1],lwipdev.mac[2],lwipdev.mac[3],lwipdev.mac[4],lwipdev.mac[5]);
	printf("̬IPַ........................%d.%d.%d.%d\r\n",lwipdev.ip[0],lwipdev.ip[1],lwipdev.ip[2],lwipdev.ip[3]);
	printf("..........................%d.%d.%d.%d\r\n",lwipdev.netmask[0],lwipdev.netmask[1],lwipdev.netmask[2],lwipdev.netmask[3]);
	printf("Ĭ..........................%d.%d.%d.%d\r\n",lwipdev.gateway[0],lwipdev.gateway[1],lwipdev.gateway[2],lwipdev.gateway[3]);
#endif
	Netif_Init_Flag=netif_add(&lwip_netif,&ipaddr,&netmask,&gw,NULL,&ethernetif_init,&ethernet_input);//бһ
	
#if LWIP_DHCP			//ʹDHCPĻ
	lwipdev.dhcpstatus=0;	//DHCPΪ0
	dhcp_start(&lwip_netif);	//DHCP
#endif
	
	if(Netif_Init_Flag==NULL)return 3;//ʧ 
	else//ӳɹ,netifΪĬֵ,Ҵnetif
	{
		netif_set_default(&lwip_netif); //netifΪĬ
		netif_set_up(&lwip_netif);		//netif
	}
	return 0;//OK.
}   

//յݺ 
void lwip_pkt_handle(void)
{
	//绺жȡյݰ䷢͸LWIP 
	ethernetif_input(&lwip_netif);
}

//LWIPѯ
void lwip_periodic_handle()
{
	
#if LWIP_TCP
	//ÿ250msһtcp_tmr()
	if (lwip_localtime - TCPTimer >= TCP_TMR_INTERVAL)
	{
		TCPTimer =  lwip_localtime;
		tcp_tmr();
	}
#endif
	//ARPÿ5sԵһ
	if ((lwip_localtime - ARPTimer) >= ARP_TMR_INTERVAL)
	{
		ARPTimer =  lwip_localtime;
		etharp_tmr();
	}

#if LWIP_DHCP //ʹDHCPĻ
	//ÿ500msһdhcp_fine_tmr()
	if (lwip_localtime - DHCPfineTimer >= DHCP_FINE_TIMER_MSECS)
	{
		DHCPfineTimer =  lwip_localtime;
		dhcp_fine_tmr();
		if ((lwipdev.dhcpstatus != 2)&&(lwipdev.dhcpstatus != 0XFF))
		{ 
			lwip_dhcp_process_handle();  //DHCP
		}
	}

	//ÿ60sִһDHCPֲڴ
	if (lwip_localtime - DHCPcoarseTimer >= DHCP_COARSE_TIMER_MSECS)
	{
		DHCPcoarseTimer =  lwip_localtime;
		dhcp_coarse_tmr();
	}  
#endif
}


//ʹDHCP
#if LWIP_DHCP

//DHCP
void lwip_dhcp_process_handle(void)
{
	u32 ip=0,netmask=0,gw=0;
	switch(lwipdev.dhcpstatus)
	{
		case 0: 	//DHCP
			dhcp_start(&lwip_netif);
			lwipdev.dhcpstatus = 1;		//ȴͨDHCPȡĵַ
			printf("ڲDHCP,Ե...........\r\n");  
			break;
		case 1:		//ȴȡIPַ
		{
			ip=lwip_netif.ip_addr.addr;		//ȡIPַ
			netmask=lwip_netif.netmask.addr;//ȡ
			gw=lwip_netif.gw.addr;			//ȡĬ 
			
			if(ip!=0)			//ȷȡIPַʱ
			{
				lwipdev.dhcpstatus=2;	//DHCPɹ
				printf("enMACַΪ:................%d.%d.%d.%d.%d.%d\r\n",lwipdev.mac[0],lwipdev.mac[1],lwipdev.mac[2],lwipdev.mac[3],lwipdev.mac[4],lwipdev.mac[5]);
				//ͨDHCPȡIPַ
				lwipdev.ip[3]=(uint8_t)(ip>>24); 
				lwipdev.ip[2]=(uint8_t)(ip>>16);
				lwipdev.ip[1]=(uint8_t)(ip>>8);
				lwipdev.ip[0]=(uint8_t)(ip);
				printf("ͨDHCPȡIPַ..............%d.%d.%d.%d\r\n",lwipdev.ip[0],lwipdev.ip[1],lwipdev.ip[2],lwipdev.ip[3]);
				//ͨDHCPȡַ
				lwipdev.netmask[3]=(uint8_t)(netmask>>24);
				lwipdev.netmask[2]=(uint8_t)(netmask>>16);
				lwipdev.netmask[1]=(uint8_t)(netmask>>8);
				lwipdev.netmask[0]=(uint8_t)(netmask);
				printf("ͨDHCPȡ............%d.%d.%d.%d\r\n",lwipdev.netmask[0],lwipdev.netmask[1],lwipdev.netmask[2],lwipdev.netmask[3]);
				//ͨDHCPȡĬ
				lwipdev.gateway[3]=(uint8_t)(gw>>24);
				lwipdev.gateway[2]=(uint8_t)(gw>>16);
				lwipdev.gateway[1]=(uint8_t)(gw>>8);
				lwipdev.gateway[0]=(uint8_t)(gw);
				printf("ͨDHCPȡĬ..........%d.%d.%d.%d\r\n",lwipdev.gateway[0],lwipdev.gateway[1],lwipdev.gateway[2],lwipdev.gateway[3]);
			}else if(lwip_netif.dhcp->tries>LWIP_MAX_DHCP_TRIES) //ͨDHCPȡIPַʧ,ҳԴ
			{
				lwipdev.dhcpstatus=0XFF;//DHCPʱʧ.
				//ʹþ̬IPַ
				IP4_ADDR(&(lwip_netif.ip_addr),lwipdev.ip[0],lwipdev.ip[1],lwipdev.ip[2],lwipdev.ip[3]);
				IP4_ADDR(&(lwip_netif.netmask),lwipdev.netmask[0],lwipdev.netmask[1],lwipdev.netmask[2],lwipdev.netmask[3]);
				IP4_ADDR(&(lwip_netif.gw),lwipdev.gateway[0],lwipdev.gateway[1],lwipdev.gateway[2],lwipdev.gateway[3]);
				printf("DHCPʱ,ʹþ̬IPַ!\r\n");
				printf("enMACַΪ:................%d.%d.%d.%d.%d.%d\r\n",lwipdev.mac[0],lwipdev.mac[1],lwipdev.mac[2],lwipdev.mac[3],lwipdev.mac[4],lwipdev.mac[5]);
				printf("̬IPַ........................%d.%d.%d.%d\r\n",lwipdev.ip[0],lwipdev.ip[1],lwipdev.ip[2],lwipdev.ip[3]);
				printf("..........................%d.%d.%d.%d\r\n",lwipdev.netmask[0],lwipdev.netmask[1],lwipdev.netmask[2],lwipdev.netmask[3]);
				printf("Ĭ..........................%d.%d.%d.%d\r\n",lwipdev.gateway[0],lwipdev.gateway[1],lwipdev.gateway[2],lwipdev.gateway[3]);
			}
		}
		break;
		default : break;
	}
}
#endif 



























