#include "led.h"
#include "delay.h"
#include "key.h"
#include "sys.h"
#include "lcd.h"
#include "usart.h"	 
#include "usmart.h"
#include "sram.h"
#include "malloc.h"
#include "enc28j60.h" 	 
#include "lwip/netif.h"
#include "lwip_comm.h"
#include "lwipopts.h"
#include "timer.h"
#include "tcp_client_demo.h"
/************************************************
 ALIENTEK ENC28J60 ʵ
 RAW APITCP Clientʵ
 ֧֣www.openedv.com
 Ա̣http://eboard.taobao.com 
 ע΢Źƽ̨΢źţ"ԭ"ѻȡSTM32ϡ
 ӿƼ޹˾  
 ߣԭ @ALIENTEK
************************************************/
extern int receNum;
extern u8 tcp_client_flag;	 //TCP Client ȫ״̬Ǳ
//UI
//mode:
//bit0:0,;1,ǰ벿UI
//bit1:0,;1,غ벿UI
void lwip_test_ui(u8 mode)
{
	u8 buf[30]; 
	POINT_COLOR=RED;
	if(mode&1<<0)
	{
		LCD_Fill(30,30,lcddev.width,110,WHITE);	//ʾ
		LCD_ShowString(30,30,200,16,16,"ENC28J60+STM32");
		LCD_ShowString(30,50,200,16,16,"Ethernet lwIP Test");
		LCD_ShowString(30,70,200,16,16,"ATOM@ALIENTEK");
		LCD_ShowString(30,90,200,16,16,"2015/4/30"); 	
	}
	if(mode&1<<1)
	{
		LCD_Fill(30,110,lcddev.width,lcddev.height,WHITE);	//ʾ
		LCD_ShowString(30,110,200,16,16,"lwIP Init Successed");
		if(lwipdev.dhcpstatus==2)sprintf((char*)buf,"DHCP IP:%d.%d.%d.%d",lwipdev.ip[0],lwipdev.ip[1],lwipdev.ip[2],lwipdev.ip[3]);//ӡ̬IPַ
		else sprintf((char*)buf,"Static IP:%d.%d.%d.%d",lwipdev.ip[0],lwipdev.ip[1],lwipdev.ip[2],lwipdev.ip[3]);//ӡ̬IPַ
		LCD_ShowString(30,130,210,16,16,buf); 
		LCD_ShowString(30,150,200,16,16,"Ethernet Speed:10M");
		LCD_ShowString(30,170,200,16,16,"PORT: 8087");
		LCD_ShowString(30,170,200,16,16,"KEY0: Send data");
	}
}

int main(void)
{	 
	u8 key;
	delay_init();	    	//ʱʼ	  
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);	 	//NVICжϷ2:2λռȼ2λӦȼ
	uart_init(115200);	 	//ڳʼΪ115200
 	LED_Init();			    //LED˿ڳʼ
	LCD_Init();				//ʼLCD
	KEY_Init();	 			//ʼ
	TIM3_Int_Init(1000,719);//ʱ3ƵΪ100hz
// 	usmart_dev.init(72);	//ʼUSMART		  
 	FSMC_SRAM_Init();		//ʼⲿSRAM
	my_mem_init(SRAMIN);	//ʼڲڴ
	my_mem_init(SRAMEX);	//ʼⲿڴ
	POINT_COLOR = RED; 		
	printf("DEVICE OK\r\n");
	//	lwip_test_ui(1);		//ǰ벿UI		    
	while(lwip_comm_init()) //lwipʼ
	{
			printf("init faild\r\n");
	}

#if LWIP_DHCP   //ʹDHCP
	while((lwipdev.dhcpstatus!=2)&&(lwipdev.dhcpstatus!=0XFF))//ȴDHCPȡɹ/ʱ
	{
		lwip_periodic_handle();	//LWIPںҪʱĺ
	}
#endif
//	lwip_test_ui(2);		//غ벿UI
printf("start test\r\n");	
	delay_ms(500);			//ʱ1s
	delay_ms(500);
	tcp_client_test();  	//TCP Clientģʽ
  while(1)
	{	
		key = KEY_Scan(0);
		if(key == KEY1_PRES||key == KEY0_PRES)		//KEY1
		{
			printf("%d\r\n",receNum);
		}
//			if((tcp_client_flag & 1<<5)) printf("TCPͻѾ,ظ\r\n");	//ӳɹ,κδ
//			else 
		tcp_client_test();		//ϿӺ,tcp_client_test()
//		}
//		delay_ms(10);
	}
}

